if (WScript.Arguments.Length != 1) {
    WriteLog("Usage: cscript FanControl4.js [on|off]");
    WScript.Quit();
}

var arg = WScript.Arguments.Item(0);

if (arg == "on") {
    TurnOn();
}
else if (arg == "off") {
    TurnOff();
}
else {
    WriteLog("Unrecognized argument: " + arg);
}

function TurnOn()
{
    WriteLog("Turning on fans...");
    PwiRequest("/fans/on");
}

function TurnOff()
{
    WriteLog("Turning off fans...");
    PwiRequest("/fans/off");
}

// Issue a request to the PWI4 HTTP server
function PwiRequest(command) {
    PWI4_PORT = 8220;

    var http = new ActiveXObject("MSXML2.ServerXMLHTTP");
    var url = "http://localhost:" + PWI4_PORT + command; 
    
    try {
        http.open("GET", url, false);
        http.setRequestHeader("Cache-Control", "max-age=0"); // Avoid getting a previous cached response back
        http.send();
    }
    catch (ex) {
        throw new Error(0x80040001, "PWI request failed. Is PWI running? Is the server enabled? Is the correct port being used?");
    }

    var responseText = http.responseText;
    return http.responseText;
}

function WriteLog(text) {
    if (typeof(WScript) === "object") {
        // Running via cscript
        WScript.Echo(text); 
    }
    else if (typeof(Console) === "object" && typeof(Console.PrintLine) !== "undefined") {
        // Running via ACP
        Console.PrintLine(text);
    }
}
